// Xshell

// Includes
#include <platform.h>
#include <print.h>
#include <xs1.h>
#include "xgc_vga_interface.h"
#include "xgc_keyboard.h"
#include "xgc_graphics.h"
#include "xgc_shell.h"
#include "xgc_services.h"
#include "FAT16_server.h"

// SD card ports, from SD card example
port p_sd_cmd = XS1_PORT_1E;
port p_sd_clk = XS1_PORT_1F;
port p_sd_dat = XS1_PORT_1G;
port p_sd_rsv = XS1_PORT_1H;

// Main
int main(void) {
	// System channels
	streaming chan services_kbd_req;
	chan services_kbd_chars, services_sd, services_shell;
	
	par {
		// System threads
		
		// Services server
		xgc_services(services_kbd_chars, services_kbd_req, services_sd, services_shell);
		// SD card server
		FAT16_server(services_sd, p_sd_cmd, p_sd_clk, p_sd_dat, p_sd_rsv);
		// Keyboard server
		keyboard(services_kbd_chars, services_kbd_req);
		// VGA manager
		vga_refresh();
		
		// Application threads
		shell(services_shell);
	}
	
	return 0;
}

