#ifndef XGC_EDITOR_H_
#define XGC_EDITOR_H_

// Includes
#include "xgc_services.h"
#include "xgc_keyboard.h"
#include "xgc_vga_interface.h"
#include <safestring.h>

// Func
extern void editor(chanend from_services, char file[]);

// Aux functions
void update_status(chanend from_services);
void update_cmd_area(chanend from_services);
void command_add_char(int ch);
void command_execute(chanend from_services);
void update_text_area(chanend from_services);
void move_cursor(int ch);
void insert_char(char ch);
void del_backchar(void);
void command_load(chanend from_services);
void command_new(chanend from_services);
void command_save(chanend from_services);
void doc_clearstate();
void command_message(chanend from_services, char text[]);
int validate_filename(chanend from_services, char fil[]);

// Defines
#define MAX_FILENAME_LEN 8
#define MAX_DOC_LEN 3000
#define MAX_EDIT_CMD_LEN 30

#endif /*XGC_EDITOR_H_*/
