// Borrowed from Roger Shepherd's keyboard handler
// Copyright 2008
// Modified for UK and Extended Keyboards

// Extended keys
// Returned as ints, note the following

#include "xgc_kbd_decode.h"
#include <print.h>

const unsigned char decode[DT_SIZE] = { 
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // F9                     
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // F5    
		PS2_NOTAKEY, // F3                     
		PS2_NOTAKEY, // F1                     
		PS2_NOTAKEY, // F2                     
		PS2_NOTAKEY, // F12                    
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // F10                    
		PS2_NOTAKEY, // F8                     
		PS2_NOTAKEY, // F6                     
		PS2_NOTAKEY, // F4                     
		0x09, // TAB                    
		0x60, // ` or |                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // Left ALT               
		PS2_SHIFT, // Left SHIFT               
		PS2_NOTAKEY, //                        
		PS2_CTRL, // Left Ctrl                 
		'q', // Q                              
		'1', // 1 or !                         
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		'z', // Z                              
		's', // S                              
		'a', // A                              
		'w', // W                              
		'2', // 2 or @                         
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		'c', // C                              
		'x', // X                              
		'd', // D                              
		'e', // E                              
		'4', // 4 or $                         
		'3', // 3 or £                         
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		' ', // Space                          
		'v', // V                              
		'f', // F                              
		't', // T                              
		'r', // R                              
		'5', // 5 or %                         
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		'n', // N                              
		'b', // B                              
		'h', // H                              
		'g', // G                              
		'y', // Y                              
		'6', // 6 or ^                         
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		'm', // M                              
		'j', // J                              
		'u', // U                              
		'7', // 7 or &                         
		'8', // 8 or *                         
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		',', // , or <                         
		'k', // K                              
		'i', // I                              
		'o', // o                        
		'0', // 0 or ) 
		'9', // 9 or (                                    
		PS2_NOTAKEY, //                                      
		PS2_NOTAKEY, //                         
		'.', // . or >
		'/', // / or ?
		'l', // L                                              
		';', // ; or :                              
		'p', // p                         
		'-', // - or _                     
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // 
		0x27,        //  ' or @                                          
		PS2_NOTAKEY, //                        
		'[', // [ or {                         
		'=', // = OR +                         
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // Caps Lock                      
		PS2_CAPS, 
		PS2_SHIFT, // Right Shift 
		0x0D, // Enter                     
		']', // ] or }                                     
		PS2_NOTAKEY, // 
		'#', // # or |                                 
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //
		'\\',        // \ or | UK KEYBOARD                                    
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //
		0x08, // Backspace                                  
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // NUM - 1 or END         
		'1', //                        
		PS2_NOTAKEY, // NUM - 4 or LEFT        
		'4', // NUM - 7 or HOME        
		'7', //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                         
		'.', // NUM - . or DEL
		'0', // NUM - 0 or INS         
		'.', // NUM - 2 or DOWN        
		'2', // NUM - 5                
		'5', // NUM - 6 or RIGHT       
		'6', // NUM - 8 or UP          
		'8', // F11                       
		0x1B, // ESC    76                   
		PS2_NUM, // NUM LOCK                    
		PS2_NOTAKEY, // NUM - + (Plus)         
		'+', // NUM 3 or PAGE DOWN     
		'3', // NUM - - (Minus)        
		'-', // NUM - *                
		'*', // NUM - 9 or PAGE UP     
		'9', // SCROLL LOCK            
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // F7                     
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY };

const unsigned char decode_shifted[DT_SIZE] = { PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //  F9                           
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //  F5                           
		PS2_NOTAKEY, //  F3                           
		PS2_NOTAKEY, //  F1                           
		PS2_NOTAKEY, //  F2                           
		PS2_NOTAKEY, //  F12                          
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //  F10                          
		PS2_NOTAKEY, //  F8                           
		PS2_NOTAKEY, //  F6                           
		PS2_NOTAKEY, //  F4                           
		0x09, //  TAB                          
		'¬', //                           
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //  Left ALT                     
		PS2_SHIFT, //  Left SHIFT                       
		PS2_NOTAKEY, //                               
		PS2_CTRL, //  Left Ctrl                        
		'Q', //  Q                                
		'!', //  1 or !                           
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //                               
		'Z', //  Z                                
		'S', //  S                                
		'A', //  A                                
		'W', //  W                                
		'"',  //  2 or "                           
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //                               
		'C', //  C                                
		'X', //  X                                
		'D', //  D                                
		'E', //  E                                
		'$', //  4 or $                           
		'£', //  3 or �                           
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //                               
		' ', //  Space                            
		'V', //  V                                
		'F', //  F                                
		'T', //  T                                
		'R', //  R                                
		'%', //  5 or %                           
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //                               
		'N', //  N                                
		'B', //  B                                
		'H', //  H                                
		'G', //  G                                
		'Y', //  Y                                
		'^', //  6 or ^                           
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //                               
		'M', //  M                                
		'J', //  J                                
		'U', //  U                                
		'&', //  7 or &                           
		'*', //  8 or *                           
		PS2_NOTAKEY, //                               
		PS2_NOTAKEY, //                               
		'<', //  , or <                           
		'K', //  K                                
		'I', //  I                                                           
		'O', // o                        
		')', // 0 or ) 
		'(', // 9 or (                                    
		PS2_NOTAKEY, //                                      
		PS2_NOTAKEY, //                         
		'>', // . or >
		'?', // / or ?
		'L', // L                                              
		':', // ; or :                              
		'P', // p                         
		'_', // - or _                     
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // 
		'@',        //  ' or @                                             
		PS2_NOTAKEY, //                        
		'{', // [ or {                         
		'+', // = OR +                         
		PS2_NOTAKEY, //                                       
		PS2_NOTAKEY, 
		PS2_CAPS,
		PS2_SHIFT, // Right Shift 
		0x0D, // Enter                     
		'}', // ] or }                                     
		PS2_NOTAKEY, // 
		'~', // # or |                                 
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //
		'|',        // \ or | UK KEYBOARD                                    
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //
		0x08, // Backspace                                  
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // NUM - 1 or END         
		'1', //                        
		PS2_NOTAKEY, // NUM - 4 or LEFT        
		'4', // NUM - 7 or HOME        
		'7', //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                         
		'.', // NUM - . or DEL
		'0', // NUM - 0 or INS         
		'.', // NUM - 2 or DOWN        
		'2', // NUM - 5                
		'5', // NUM - 6 or RIGHT       
		'6', // NUM - 8 or UP          
		'8', // F11                       
		0x1B, // ESC    76                   
		PS2_NUM, // NUM LOCK                    
		PS2_NOTAKEY, // NUM - + (Plus)         
		'+', // NUM 3 or PAGE DOWN     
		'3', // NUM - - (Minus)        
		'-', // NUM - *                
		'*', // NUM - 9 or PAGE UP     
		'9', // SCROLL LOCK            
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, // F7                     
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY, //                        
		PS2_NOTAKEY };

unsigned char decode_press(unsigned char press) {
	int decoded_press;

	// can byte be looked up?
	if ((int) press < DT_SIZE) {
		decoded_press = decode[(int) press];
		// check for special key
		// this version just deals with shift and unshifted
		if (decoded_press >= PS2_MINNONKEY) {
			if (decoded_press==PS2_NOTAKEY) {
				decoded_press = PS2_NOTAKEY;
			} else if (decoded_press==PS2_SHIFT) {
				// ledecoded_press = PS2_NOTAKEY;
			} else if (decoded_press==PS2_CTRL) {
				decoded_press = PS2_CTRL;
			} else if (decoded_press==PS2_CAPS) {
				//decoded_press = PS2_NOTAKEY;
			} else if (decoded_press==PS2_NUM) {
				decoded_press = PS2_NOTAKEY;
			}
		}
	} else {
		// not handled by table; deal with release only
		if (press == PS2_RELEASE) {
		  decoded_press = PS2_RELEASE;
	    } else {
	      decoded_press = PS2_NOTAKEY;
	    }
		
		if (press==PS2_EXT) decoded_press = PS2_EXT;
	}
	return (decoded_press);
}


unsigned char decode_shift_press(unsigned char press) {
	int decoded_press;

	// can byte be looked up?
	if ((int) press < DT_SIZE) {
		decoded_press = decode_shifted[(int) press];
		// check for special key
		// this version just deals with shift and unshifted
		if (decoded_press >= PS2_MINNONKEY) {
			if (decoded_press==PS2_NOTAKEY) {
				decoded_press = PS2_NOTAKEY;
			} else if (decoded_press==PS2_SHIFT) {
				// ledecoded_press = PS2_NOTAKEY;
			} else if (decoded_press==PS2_CTRL) {
				decoded_press = PS2_CTRL;
			} else if (decoded_press==PS2_CAPS) {
				decoded_press = PS2_NOTAKEY;
			} else if (decoded_press==PS2_NUM) {
				decoded_press = PS2_NOTAKEY;
			}
		}
	} else {
		// not handled by table; deal with release only
		if (press == PS2_RELEASE) {
		  decoded_press = PS2_RELEASE;
	    } else {
	      decoded_press = PS2_NOTAKEY;
	    }
		
		if (press==PS2_EXT) decoded_press = PS2_EXT;
	}
	return (decoded_press);
}
