#ifndef XGC_SDCARD_SHARED_H_
#define XGC_SDCARD_SHARED_H_

// Shared functions for accessing the SD Card

#include <xs1.h>
#include <platform.h>
#include <safestring.h>
#include <print.h>
#include "SD_phy.h"
#include "SD_link.h"
#include "FAT16.h"
#include "FAT16_server.h"
#include "FAT16_client.h"

// Is an sd card inserted?
extern int sdcard_check(chanend sdc);
extern int sdcard_load(chanend sdc, char filename[], char dest[], int dest_size);
extern int sdcard_write(chanend sdc, char filename[], char src[], int src_size);
extern int sdcard_delete(chanend sdc, char filename[]);
extern int sdcard_exists(chanend sdc, char filename[]) ;
extern int sdcard_cat(chanend sdc, char dest_arr[], int dest_size);

#define MAX_FILENAME 20

#endif /*XGC_SDCARD_SHARED_H_*/
