#ifndef XGC_SHELL_H_
#define XGC_SHELL_H_

// Define commands for a simple shell

// Shell should manage launching of scripts in a new interpreter.

// Includes
#include <xs1.h>
#include <platform.h>
#include <safestring.h>
#include "xgc_graphics.h"
#include "xgc_vga_interface.h"
#include "xgc_keyboard.h"
#include "xgc_services.h"

// Defines
#define MAX_CMD_LEN (MAX_CHARS_LINE-3)
#define SDPRINT_NAME ("PRINT.TXT")

// Functions
extern void shell(chanend from_services);
extern void shell_commands(char command[], chanend from_sdc);
extern void substr(char src[], char dest[], int start, int end, int stripspace);
void sh_backspace_char(char command[], int &command_pointer, int &cursor);
void sh_insert_char(char command[], char ch, int &command_pointer, int &cursor);
void sh_redraw_command(chanend from_services, char command[], int &command_pointer, int &cursor, int show_cursor);

// System shell functions
void sdcheck(chanend from_services);
void sdcat(chanend from_services);
void sdmore(chanend from_services, char command[]);
void sdprint(chanend from_services, char command[]);
void sddel(chanend from_services, char command[]) ;
void edit(chanend from_services, char command[]);
void sdtouch(chanend from_services, char command[]);
void sdinterpret(chanend from_services, char command[]);
void cmdeditor(chanend from_services, char command[]);

#endif /*XGC_SHELL_H_*/

