// XGC VGA Driver

// VGA, 80x60

#ifndef _xgc_vga_interface_h_
#define _xgc_vga_interface_h_

// X Defs
#define XPIXELS 640
#define XPXBYTES (XPIXELS/4)
#define HSYNC_FRONT_PORCH 16
#define HSYNC_SYNC_PULSE 96
#define HSYNC_BACK_PORCH 48

// Y Degs
#define YLINES  480
#define VSYNC_FRONT_PORCH 11
#define VSYNC_SYNC_PULSE 2
#define VSYNC_BACK_PORCH 31

// Clock
#define CLKDIV 4	// Must /2 when passed to set_clock_div as hw * 2

// Useful definitions for handling characters
#define FONT_SQ_SIZE 8
#define MAX_CHARS_LINE (XPIXELS/FONT_SQ_SIZE)	// 640 / 8 = 80
#define MAX_LINES (YLINES/FONT_SQ_SIZE)			// 480 / 8 = 60

// Function definitions
extern void vga_refresh();

#endif

